\documentclass[../main.tex]{subfiles}
\graphicspath{{\subfix{../images/}}}

\begin{document}

\section{Lessons Learnt}\label{sec-feedback}
After 2 years of exploitation in a production environment of the logs centralisation, we are able to draw up an assessment of our federated statistics system.

The overall quality of the centralised indicators strongly depends on the coverage of aggregated values from each EIDA node (see Section~\ref{sec:coverage}).
If an EIDA node fails to send the aggregates during some time, the centralised result becomes less accurate.
EIDA therefore decided to monitor the ingestion operations at the central node.
The coverage level is checked by the central service managers and by nodes operator in order to make sure that the statistics are correctly covered.
Until now, the coverage rate \replaced{meets the need for meaningful indicators}{is satisfactory}, around 98\%.
In case of problems, the EIDA node operators have been able to resubmit their aggregates and fill the gaps.
The key to this good coverage rate is:
\begin{itemize}
  \item a simple and robust architecture and implementation of the aggregation system;
  \item a simple way to ship the aggregated data;
  \item a simple way to deploy and upgrade the aggregator program on every node;
  \item a simple way for node operators to check their coverage;
  \item the possibility for all node operators to send data from the past, in order to recover missing time windows.
\end{itemize}


In case of the necessity to upgrade the aggregator program, all the EIDA nodes need to be coordinated.
In practice, the central system stores the operator contacts for each EIDA node in order to ease the coordination process.
Coordination has proven to be as efficient as the least responsive EIDA node, therefore, we promote within the ETC that the operators of each EIDA node need to realise the upgrade process rapidly.
Furthermore, changes and updates need to be designed with a transition period in mind, as software updates and migrations do not take place simultaneously at all EIDA nodes, but rather roll out some period of time which is dependent on, for example, local workload and staff availability.

None of those difficulties have so far been an issue to keep the system operational, possibly due to the long experience of the EIDA nodes concerning robust operational environments to ensure high uptime.

For interested readers, we refer to Supplementary Material 2 which states a set of steps to implement a similar system in other contexts.

\end{document}

%%% Local Variables:
%%% mode: latex
%%% ispell-local-dictionary: en_GB
%%% End:
